package cn.com.qmth.examcloud.exchange.base.enums;
/**
 * @author  	chenken
 * @date    	2018年5月17日 下午2:56:03
 * @company 	QMTH
 * @description 机构ID与service名称枚举类
 */
public enum OrgIdServiceEnum {
	
	SYDX(1L,"sydxScorePushService","石油大学推送成绩service"),
	
	XNCD(1384L,"xncdScorePushService","西南财大推送成绩service");
	
	private OrgIdServiceEnum(Long orgId, String serviceName, String desc) {
		this.orgId = orgId;
		this.serviceName = serviceName;
		this.desc = desc;
	}
	
	public static OrgIdServiceEnum getServiceNameByOrgId(Long orgId){
		if(orgId == null){
			return null;
		}
		for(OrgIdServiceEnum orgIdServiceEnum:OrgIdServiceEnum.values()){
			if(orgId.longValue() == orgIdServiceEnum.getOrgId().longValue()){
				return orgIdServiceEnum;
			}
		}
		return null;
	}

	private Long orgId;
	
	private String serviceName;
	
	private String desc;

	public Long getOrgId() {
		return orgId;
	}

	public void setOrgId(Long orgId) {
		this.orgId = orgId;
	}

	public String getServiceName() {
		return serviceName;
	}

	public void setServiceName(String serviceName) {
		this.serviceName = serviceName;
	}

	public String getDesc() {
		return desc;
	}

	public void setDesc(String desc) {
		this.desc = desc;
	}
	
}

