package cn.com.qmth.examcloud.exchange.inner.api.controller;

import java.io.IOException;

import javax.servlet.ServletInputStream;
import javax.servlet.http.HttpServletRequest;

import org.apache.poi.util.IOUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import cn.com.qmth.examcloud.commons.base.exception.ExamCloudRuntimeException;
import cn.com.qmth.examcloud.commons.base.exception.StatusException;
import cn.com.qmth.examcloud.commons.base.util.AES;
import cn.com.qmth.examcloud.commons.web.security.bean.User;
import cn.com.qmth.examcloud.commons.web.support.ControllerSupport;
import cn.com.qmth.examcloud.exchange.inner.service.UpyunService;
import cn.com.qmth.examcloud.exchange.inner.service.bean.UpyunPathEnvironmentInfo;
import io.swagger.annotations.ApiOperation;

/**
 * Upyun服务
 *
 * @author WANGWEI
 * @date 2018年11月21日
 * @Copyright (c) 2018-? http://qmth.com.cn All Rights Reserved.
 */
@RestController
@RequestMapping("${$rmp.ctr.exchange.inner}/upyun")
public class UpyunController extends ControllerSupport {

	@Autowired
	UpyunService upyunService;

	AES aes = new AES();

	@ApiOperation(value = "保存照片")
	@PutMapping("put/{siteId}/{fileSuffix}")
	public String putFile(@PathVariable String siteId, @PathVariable String fileSuffix,
			HttpServletRequest req) {

		User accessUser = getAccessUser();

		if (!fileSuffix.matches("\\w+")) {
			throw new StatusException("EX-600100", "fileSuffix is wrong");
		}

		fileSuffix = "." + fileSuffix;

		ServletInputStream in = null;
		try {
			in = req.getInputStream();

			UpyunPathEnvironmentInfo env = new UpyunPathEnvironmentInfo();
			env.setRootOrgId(String.valueOf(accessUser.getRootOrgId()));
			env.setUserId(String.valueOf(accessUser.getUserId()));
			env.setFileSuffix(fileSuffix);
			String url = upyunService.writeFile(siteId, env, in);
			url = aes.encrypt(url);
			return url;
		} catch (IOException e) {
			throw new ExamCloudRuntimeException(e);
		} finally {
			IOUtils.closeQuietly(in);
		}
	}

}
