package cn.com.qmth.examcloud.exchange.inner.api.provider;

import java.io.File;

import org.apache.commons.fileupload.disk.DiskFileItem;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.multipart.commons.CommonsMultipartFile;

import cn.com.qmth.examcloud.commons.base.util.AES;
import cn.com.qmth.examcloud.commons.web.support.ControllerSupport;
import cn.com.qmth.examcloud.exchange.inner.api.UpyunCloudService;
import cn.com.qmth.examcloud.exchange.inner.api.request.PutFileReq;
import cn.com.qmth.examcloud.exchange.inner.api.response.PutFileResp;
import cn.com.qmth.examcloud.exchange.inner.service.UpyunService;
import cn.com.qmth.examcloud.exchange.inner.service.bean.UpyunPathEnvironmentInfo;

/**
 * Upyun服务
 *
 * @author WANGWEI
 * @date 2018年11月21日
 * @Copyright (c) 2018-? http://qmth.com.cn All Rights Reserved.
 */
@RestController
@RequestMapping("${$rmp.cloud.exchange.inner}/upyun")
public class UpyunCloudServiceProvider extends ControllerSupport implements UpyunCloudService {

	private static final long serialVersionUID = -6911335293165224994L;

	@Autowired
	UpyunService upyunService;

	AES aes = new AES();

	@PostMapping("putFile")
	@Override
	public PutFileResp putFile(PutFileReq req) {
		String fileSuffix = req.getFileSuffix();
		Long rootOrgId = req.getRootOrgId();
		Long userId = req.getUserId();
		String siteId = req.getSiteId();
		CommonsMultipartFile file = req.getFile();
		DiskFileItem item = (DiskFileItem) file.getFileItem();
		File storeLocation = item.getStoreLocation();

		UpyunPathEnvironmentInfo env = new UpyunPathEnvironmentInfo();
		env.setRootOrgId(String.valueOf(rootOrgId));
		env.setUserId(String.valueOf(userId));
		env.setFileSuffix(fileSuffix);

		String url = upyunService.writeFile(siteId, env, storeLocation);
		url = aes.encrypt(url);

		PutFileResp resp = new PutFileResp();
		resp.setUrl(url);
		return resp;
	}

}
