package cn.com.qmth.examcloud.exchange.inner.service.impl;

import java.io.File;
import java.io.InputStream;

import org.springframework.stereotype.Service;

import cn.com.qmth.examcloud.commons.base.logging.ExamCloudLog;
import cn.com.qmth.examcloud.commons.base.logging.ExamCloudLogFactory;
import cn.com.qmth.examcloud.commons.base.util.FreeMarkerUtil;
import cn.com.qmth.examcloud.exchange.inner.service.UpyunService;
import cn.com.qmth.examcloud.exchange.inner.service.bean.UpyunPathEnvironmentInfo;
import cn.com.qmth.examcloud.exchange.inner.service.upyun.UpYunClient;
import cn.com.qmth.examcloud.exchange.inner.service.upyun.UpyunSite;
import cn.com.qmth.examcloud.exchange.inner.service.upyun.UpyunSiteManager;

/**
 * 类注释
 *
 * @author WANGWEI
 * @date 2018年9月4日
 * @Copyright (c) 2018-? http://qmth.com.cn All Rights Reserved.
 */
@Service
public class UpyunServiceImpl implements UpyunService {

	protected ExamCloudLog log = ExamCloudLogFactory.getLog(this.getClass());

	@Override
	public String writeFile(String siteId, UpyunPathEnvironmentInfo env, InputStream in) {
		env.setCurrentTimeMillis(String.valueOf(System.currentTimeMillis()));

		UpyunSite upyunSite = UpyunSiteManager.getUpyunSite(siteId);
		UpYunClient upYunClient = UpyunSiteManager.getUpYunClient(siteId);

		String path = FreeMarkerUtil.process(upyunSite.getPath(), env);
		String url = upYunClient.writeFile(path, in);
		return url;
	}

	@Override
	public String writeFile(String siteId, UpyunPathEnvironmentInfo env, File file) {
		env.setCurrentTimeMillis(String.valueOf(System.currentTimeMillis()));

		UpyunSite upyunSite = UpyunSiteManager.getUpyunSite(siteId);
		UpYunClient upYunClient = UpyunSiteManager.getUpYunClient(siteId);

		String path = FreeMarkerUtil.process(upyunSite.getPath(), env);
		String url = upYunClient.writeFile(path, file);
		return url;
	}

}
