package cn.com.qmth.examcloud.exchange.outer.api.bean;

import cn.com.qmth.examcloud.commons.web.cloud.api.JsonSerializable;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

/**
 * 类注释
 *
 * @author WANGWEI
 * @date 2018年11月14日
 * @Copyright (c) 2018-? http://qmth.com.cn All Rights Reserved.
 */
@ApiModel(value = "examStudentBean", description = "考生信息")
public class OuterExamStudentBean implements JsonSerializable {
	private static final long serialVersionUID = 2079003980099252759L;

	/**
	 * 顶级机构ID
	 */
	@ApiModelProperty(value = "顶级机构", example = "0", required = true)
	private Long rootOrgId;

	/**
	 * 考试ID
	 */
	@ApiModelProperty(value = "考试ID", example = "100", required = true)
	private Long examId;

	/**
	 * 考试名称
	 */
	@ApiModelProperty(value = "考试名称", example = "2018年秋季入学考试", required = true)
	private String examName;

	/**
	 * 学生姓名
	 */
	@ApiModelProperty(value = "学生姓名", example = "陈圆圆", required = true)
	private String studentName;

	/**
	 * 学生学号
	 */
	@ApiModelProperty(value = "学生学号", example = "2018001001", required = true)
	private String studentCode;

	/**
	 * 学生身份证号
	 */
	@ApiModelProperty(value = "学生身份证号", example = "XXXXXXXXXXXXXXXXXX", required = true)
	private String identityNumber;

	/**
	 * 考试课程名称
	 */
	@ApiModelProperty(value = "考试课程名称", example = "大学英语", required = true)
	private String courseName;

	/**
	 * 考试课程code
	 */
	@ApiModelProperty(value = "考试课程code", example = "K2", required = true)
	private String courseCode;

	/**
	 * 考试课程level
	 */
	@ApiModelProperty(value = "考试课程level.  ZSB:专升本;GQZ:高起专;GQB:高起本;ALL:不限", example = "ALL", required = true)

	private String courseLevel;

	/**
	 * 试卷类型
	 */
	@ApiModelProperty(value = "试卷类型,大写字母A-Z", example = "X", required = true)
	private String paperType;

	public Long getRootOrgId() {
		return rootOrgId;
	}

	public void setRootOrgId(Long rootOrgId) {
		this.rootOrgId = rootOrgId;
	}

	public Long getExamId() {
		return examId;
	}

	public void setExamId(Long examId) {
		this.examId = examId;
	}

	public String getExamName() {
		return examName;
	}

	public void setExamName(String examName) {
		this.examName = examName;
	}

	public String getStudentName() {
		return studentName;
	}

	public void setStudentName(String studentName) {
		this.studentName = studentName;
	}

	public String getStudentCode() {
		return studentCode;
	}

	public void setStudentCode(String studentCode) {
		this.studentCode = studentCode;
	}

	public String getIdentityNumber() {
		return identityNumber;
	}

	public void setIdentityNumber(String identityNumber) {
		this.identityNumber = identityNumber;
	}

	public String getCourseName() {
		return courseName;
	}

	public void setCourseName(String courseName) {
		this.courseName = courseName;
	}

	public String getCourseCode() {
		return courseCode;
	}

	public void setCourseCode(String courseCode) {
		this.courseCode = courseCode;
	}

	public String getCourseLevel() {
		return courseLevel;
	}

	public void setCourseLevel(String courseLevel) {
		this.courseLevel = courseLevel;
	}

	public String getPaperType() {
		return paperType;
	}

	public void setPaperType(String paperType) {
		this.paperType = paperType;
	}

}
