package cn.com.qmth.examcloud.exchange.outer.api.bean;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import java.util.Date;

import cn.com.qmth.examcloud.commons.web.cloud.api.JsonSerializable;

/**
 * 
 * @author  	chenken
 * @date    	2018年11月27日 下午5:41:09
 * @company 	QMTH
 * @description OuterGetScoreDataBean.java
 */
@ApiModel(value = "scoreDataBean", description = "考生成绩数据")
public class OuterScoreDataBean implements JsonSerializable{

	/**
	 * 
	 */
	private static final long serialVersionUID = 7476060044159007486L;

	@ApiModelProperty(value = "考试记录ID", example = "1", required = true)
	private Long examRecordDataId;
	
	@ApiModelProperty(value = "学生姓名", example = "XX", required = true)
	private String studentName;
	
	@ApiModelProperty(value = "学生学号", example = "X000001", required = true)
	private String studentCode;
	
	@ApiModelProperty(value = "学生身份证号码", example = "10XXXX", required = true)
	private String identityNumber;
	
	@ApiModelProperty(value = "课程名称", example = "语文001", required = true)
	private String courseName;
	
	@ApiModelProperty(value = "课程code", example = "A000001", required = true)
	private String courseCode;
	
	@ApiModelProperty(value = "开考时间", example = "2018-11-16 10:00:00", required = true)
	private Date startTime;
	
	@ApiModelProperty(value = "交卷时间", example = "2018-11-16 10:30:00", required = true)
	private Date endTime;
	
	@ApiModelProperty(value = "得分", example = "100.0", required = true)
	private Double totalScore;
	
	@ApiModelProperty(value = "是否异常数据", example = "false", required = true)
	private Boolean isWarn;
	
	@ApiModelProperty(value = "是否被审核", example = "false", required = true)
	private Boolean isAudit;
	
	@ApiModelProperty(value = "是否违纪", example = "false", required = true)
	private Boolean isIllegality;
	
	public Long getExamRecordDataId() {
		return examRecordDataId;
	}
	public void setExamRecordDataId(Long examRecordDataId) {
		this.examRecordDataId = examRecordDataId;
	}
	public String getStudentName() {
		return studentName;
	}
	public void setStudentName(String studentName) {
		this.studentName = studentName;
	}
	public String getStudentCode() {
		return studentCode;
	}
	public void setStudentCode(String studentCode) {
		this.studentCode = studentCode;
	}
	public String getIdentityNumber() {
		return identityNumber;
	}
	public void setIdentityNumber(String identityNumber) {
		this.identityNumber = identityNumber;
	}
	public String getCourseName() {
		return courseName;
	}
	public void setCourseName(String courseName) {
		this.courseName = courseName;
	}
	public String getCourseCode() {
		return courseCode;
	}
	public void setCourseCode(String courseCode) {
		this.courseCode = courseCode;
	}
	public Date getStartTime() {
		return startTime;
	}
	public void setStartTime(Date startTime) {
		this.startTime = startTime;
	}
	public Date getEndTime() {
		return endTime;
	}
	public void setEndTime(Date endTime) {
		this.endTime = endTime;
	}
	public Double getTotalScore() {
		return totalScore;
	}
	public void setTotalScore(Double totalScore) {
		this.totalScore = totalScore;
	}
	public Boolean getIsWarn() {
		return isWarn;
	}
	public void setIsWarn(Boolean isWarn) {
		this.isWarn = isWarn;
	}
	public Boolean getIsAudit() {
		return isAudit;
	}
	public void setIsAudit(Boolean isAudit) {
		this.isAudit = isAudit;
	}
	public Boolean getIsIllegality() {
		return isIllegality;
	}
	public void setIsIllegality(Boolean isIllegality) {
		this.isIllegality = isIllegality;
	}
	
	
}
