package cn.com.qmth.examcloud.exchange.outer.api.request;

import java.util.Date;

import cn.com.qmth.examcloud.commons.web.cloud.api.BaseRequest;
import io.swagger.annotations.ApiModelProperty;

/**
 * 类注释
 *
 * @author WANGWEI
 * @date 2018年11月16日
 * @Copyright (c) 2018-? http://qmth.com.cn All Rights Reserved.
 */
public class OuterSaveExamReq extends BaseRequest {

	private static final long serialVersionUID = 8298816850875139485L;

	@ApiModelProperty(value = "顶级机构", example = "0", required = true)
	private Long rootOrgId;

	@ApiModelProperty(value = " 考试批次开始时间", example = "2018-10-10 08:00:00", required = true)
	private Date beginTime;

	@ApiModelProperty(value = " 考试批次结束时间", example = "2018-10-10 08:00:00", required = true)
	private Date endTime;

	@ApiModelProperty(value = "考试名称", example = "2018年6月期末考试", required = true)
	private String name;

	@ApiModelProperty(value = " 考试类型(ONLINE:网考;TRADITION:传统;OFFLINE:离线;PRACTICE:练习;PRINT_EXAM:PRINT_EXAM.)", example = "ONLINE", required = true)
	private String examType;

	@ApiModelProperty(value = "考试时长(单位：分钟)", example = "120", required = true)
	private Integer duration;

	@ApiModelProperty(value = "考试备注", example = "xxx", required = true)
	private String remark;

	@ApiModelProperty(value = "考试次数", example = "2", required = true)
	private Long examTimes;

	public Long getRootOrgId() {
		return rootOrgId;
	}

	public void setRootOrgId(Long rootOrgId) {
		this.rootOrgId = rootOrgId;
	}

	public Date getBeginTime() {
		return beginTime;
	}

	public void setBeginTime(Date beginTime) {
		this.beginTime = beginTime;
	}

	public Date getEndTime() {
		return endTime;
	}

	public void setEndTime(Date endTime) {
		this.endTime = endTime;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getExamType() {
		return examType;
	}

	public void setExamType(String examType) {
		this.examType = examType;
	}

	public Integer getDuration() {
		return duration;
	}

	public void setDuration(Integer duration) {
		this.duration = duration;
	}

	public String getRemark() {
		return remark;
	}

	public void setRemark(String remark) {
		this.remark = remark;
	}

	public Long getExamTimes() {
		return examTimes;
	}

	public void setExamTimes(Long examTimes) {
		this.examTimes = examTimes;
	}

}
