package cn.com.qmth.examcloud.exchange.outer.api.request.cug;

import cn.com.qmth.examcloud.commons.web.cloud.api.BaseRequest;
import io.swagger.annotations.ApiModelProperty;

/**
 * 类注释
 *
 * @author WANGWEI
 * @date 2018年11月16日
 * @Copyright (c) 2018-? http://qmth.com.cn All Rights Reserved.
 */
public class OuterSaveCugStudentAndExamStudentReq extends BaseRequest {

	private static final long serialVersionUID = 8293200048902081959L;

	@ApiModelProperty(value = "学生姓名", example = "陈圆圆", required = true)
	private String name;

	@ApiModelProperty(value = "顶级机构", example = "0", required = true)
	private Long rootOrgId;

	@ApiModelProperty(value = "学习中心编码", example = "LC111", required = true)
	private String orgCode;

	@ApiModelProperty(value = "学习中心名称", example = "XXX", required = true)
	private String orgName;

	@ApiModelProperty(value = "学生学号", example = "2018001001", required = true)
	private String studentCode;

	@ApiModelProperty(value = "学生身份证号", example = "XXXXXXXXXXXXXXXXXX", required = true)
	private String identityNumber;

	@ApiModelProperty(value = "备注", example = "XX", required = false)
	private String remark;

	@ApiModelProperty(value = "照片URL", example = "http://xxxx.xx/123.jpg", required = false)
	private String photoUrl;

	@ApiModelProperty(value = "手机号码", example = "XXXXXXXXXXX", required = true)
	private String phoneNumber;

	@ApiModelProperty(value = "操作者", example = "XX系统", required = true)
	private String operator;

	@ApiModelProperty(value = "考试名称", example = "2018年秋季入学考试", required = true)
	private String examName;

	@ApiModelProperty(value = "专业名称", example = "计算机", required = false)
	private String specialtyName;

	@ApiModelProperty(value = "课程组", example = "本科", required = true)
	private String courseGroupName;

	@ApiModelProperty(value = "试卷类型,大写字母A-Z", example = "X", required = true)
	private String paperType;

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public Long getRootOrgId() {
		return rootOrgId;
	}

	public void setRootOrgId(Long rootOrgId) {
		this.rootOrgId = rootOrgId;
	}

	public String getOrgCode() {
		return orgCode;
	}

	public void setOrgCode(String orgCode) {
		this.orgCode = orgCode;
	}

	public String getOrgName() {
		return orgName;
	}

	public void setOrgName(String orgName) {
		this.orgName = orgName;
	}

	public String getStudentCode() {
		return studentCode;
	}

	public void setStudentCode(String studentCode) {
		this.studentCode = studentCode;
	}

	public String getIdentityNumber() {
		return identityNumber;
	}

	public void setIdentityNumber(String identityNumber) {
		this.identityNumber = identityNumber;
	}

	public String getRemark() {
		return remark;
	}

	public void setRemark(String remark) {
		this.remark = remark;
	}

	public String getPhotoUrl() {
		return photoUrl;
	}

	public void setPhotoUrl(String photoUrl) {
		this.photoUrl = photoUrl;
	}

	public String getPhoneNumber() {
		return phoneNumber;
	}

	public void setPhoneNumber(String phoneNumber) {
		this.phoneNumber = phoneNumber;
	}

	public String getOperator() {
		return operator;
	}

	public void setOperator(String operator) {
		this.operator = operator;
	}

	public String getExamName() {
		return examName;
	}

	public void setExamName(String examName) {
		this.examName = examName;
	}

	public String getSpecialtyName() {
		return specialtyName;
	}

	public void setSpecialtyName(String specialtyName) {
		this.specialtyName = specialtyName;
	}

	public String getCourseGroupName() {
		return courseGroupName;
	}

	public void setCourseGroupName(String courseGroupName) {
		this.courseGroupName = courseGroupName;
	}

	public String getPaperType() {
		return paperType;
	}

	public void setPaperType(String paperType) {
		this.paperType = paperType;
	}

}
