package cn.com.qmth.examcloud.exchange.outer.api.response;

import java.util.Date;

import cn.com.qmth.examcloud.commons.web.cloud.api.BaseResponse;
import io.swagger.annotations.ApiModelProperty;

/**
 * 类注释
 *
 * @author WANGWEI
 * @date 2018年11月16日
 * @Copyright (c) 2018-? http://qmth.com.cn All Rights Reserved.
 */
public class OuterGetExamResp extends BaseResponse {

	private static final long serialVersionUID = 1030154836013325322L;

	/**
	 * ID
	 */
	@ApiModelProperty(value = "考试ID", example = "128", required = true)
	private Long id;

	/**
	 * 顶级机构Id
	 */
	@ApiModelProperty(value = "顶级机构", example = "0", required = true)
	private Long rootOrgId;

	/**
	 * 考试批次开始时间
	 */
	@ApiModelProperty(value = " 考试批次开始时间", example = "2018-10-10 08:00:00", required = true)
	private Date beginTime;

	/**
	 * 考试批次结束时间
	 */
	@ApiModelProperty(value = " 考试批次结束时间", example = "2018-10-10 08:00:00", required = true)
	private Date endTime;

	/**
	 * 考试名称
	 */
	@ApiModelProperty(value = "考试名称", example = "2018年6月期末考试", required = true)
	private String name;

	/**
	 * 考试类型
	 */
	@ApiModelProperty(value = " 考试类型(ONLINE:网考;TRADITION:传统;OFFLINE:离线;PRACTICE:练习;PRINT_EXAM:PRINT_EXAM.)", example = "ONLINE", required = true)
	private String examType;

	/**
	 * 考试时长(分钟)
	 */
	@ApiModelProperty(value = "考试时长(单位：分钟)", example = "120", required = true)
	private Integer duration;

	/**
	 * 是否可用
	 */
	@ApiModelProperty(value = "是否可用", example = "true", required = true)
	private Boolean enable;

	/**
	 * 考试备注
	 */
	@ApiModelProperty(value = "考试备注", example = "xxx", required = true)
	private String remark;

	/**
	 * 考试次数
	 */
	@ApiModelProperty(value = "考试次数", example = "2", required = true)
	private Long examTimes;

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public Long getRootOrgId() {
		return rootOrgId;
	}

	public void setRootOrgId(Long rootOrgId) {
		this.rootOrgId = rootOrgId;
	}

	public Date getBeginTime() {
		return beginTime;
	}

	public void setBeginTime(Date beginTime) {
		this.beginTime = beginTime;
	}

	public Date getEndTime() {
		return endTime;
	}

	public void setEndTime(Date endTime) {
		this.endTime = endTime;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getExamType() {
		return examType;
	}

	public void setExamType(String examType) {
		this.examType = examType;
	}

	public Integer getDuration() {
		return duration;
	}

	public void setDuration(Integer duration) {
		this.duration = duration;
	}

	public Boolean getEnable() {
		return enable;
	}

	public void setEnable(Boolean enable) {
		this.enable = enable;
	}

	public String getRemark() {
		return remark;
	}

	public void setRemark(String remark) {
		this.remark = remark;
	}

	public Long getExamTimes() {
		return examTimes;
	}

	public void setExamTimes(Long examTimes) {
		this.examTimes = examTimes;
	}

}
