package cn.com.qmth.examcloud.exchange.outer.service.bean;

import java.io.Serializable;

public class ExamStudent implements Serializable {

    private static final long serialVersionUID = 757531976286006550L;

    private long id;

    private String name;

    private Long examId;
    /**
     * 学校id
     */
    private Long rootOrgId;
    /**
     * 学习中心id
     */
    private Long orgId;
    /**
     * 学习中心code
     */
    private String orgCode;
    private String orgName;

    private String studentCode;

    private String identityNumber;

    private String examNumber;

    private String courseCode;

    private String courseName;

    private String courseLevel;

    /**
     * 试卷类型
     */
    private String paperType;
    /**
     * 学位
     */
    private Boolean degree;

    private String specialtyName;
    /**
	 * 专业code
	 */
	private String specialtyCode;

    /**
     * 是否重修
     */
    private Boolean repair;

    /**
     * 年级
     */
    private String grade;
    /**
     * 是否毕业
     */
    private Boolean graduated;
    
    /**
     * 入学考试:recruit
     * 毕业：graduated
     * 非毕业:studying
     */
    private String remark;

    /**
     * 是否缺考
     * 1:不缺考
     * 0：缺考
     */
    private Boolean finished;

    /**
     * 学生id
     */
    private Long studentId;

    private String phone;
    private String infoCollector;
    
    /**
	 * 正常考试次数  不含重考
	 */
	private Integer normalExamTimes;
	/**
	 * 是否为重考
	 */
	private Boolean isReexamine;
	
	/**
	 * 重考原因类型
	 */
	private String reexamineType;
	/**
	 * 重考原因详情
	 */
	private String reexamineDetail;
	/**
	 * 重考已完成  true:是 false:否
	 */
	private Boolean reexamineCompleted;

    /**
     * 考试开始时间(针对学生,网考使用)
     */
    private String examBeginTime;

    /**
     * 考试结束时间(针对学生,网考使用)
     */
    private String examEndTime;

    /**
     * 是否可上传
     */
    private Boolean canUpload;

	public ExamStudent() {}
	
    public static long getSerialVersionUID() {
        return serialVersionUID;
    }

    public long getId() {
        return id;
    }

    public void setId(long id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public Long getExamId() {
		return examId;
	}

	public void setExamId(Long examId) {
		this.examId = examId;
	}

	public String getStudentCode() {
        return studentCode;
    }

    public void setStudentCode(String studentCode) {
        this.studentCode = studentCode;
    }

    public String getIdentityNumber() {
        return identityNumber;
    }

    public void setIdentityNumber(String identityNumber) {
        this.identityNumber = identityNumber;
    }

    public String getExamNumber() {
        return examNumber;
    }

    public void setExamNumber(String examNumber) {
        this.examNumber = examNumber;
    }

    public String getCourseCode() {
        return courseCode;
    }

    public void setCourseCode(String courseCode) {
        this.courseCode = courseCode;
    }

    public String getCourseName() {
        return courseName;
    }

    public void setCourseName(String courseName) {
        this.courseName = courseName;
    }

    public String getSpecialtyName() {
        return specialtyName;
    }

    public void setSpecialtyName(String specialtyName) {
        this.specialtyName = specialtyName;
    }

    public String getRemark() {
        return remark;
    }

    public void setRemark(String remark) {
        this.remark = remark;
    }

    public String getGrade() {
        return grade;
    }

    public void setGrade(String grade) {
        this.grade = grade;
    }

    public static long getSerialversionuid() {
        return serialVersionUID;
    }

    public Long getRootOrgId() {
        return rootOrgId;
    }

    public void setRootOrgId(Long rootOrgId) {
        this.rootOrgId = rootOrgId;
    }

    public Long getOrgId() {
        return orgId;
    }

    public void setOrgId(Long orgId) {
        this.orgId = orgId;
    }

    public String getOrgCode() {
        return orgCode;
    }

    public void setOrgCode(String orgCode) {
        this.orgCode = orgCode;
    }

    public String getPaperType() {
        return paperType;
    }

    public void setPaperType(String paperType) {
        this.paperType = paperType;
    }

    public String getCourseLevel() {
        return courseLevel;
    }

    public void setCourseLevel(String courseLevel) {
        this.courseLevel = courseLevel;
    }

    public Boolean getDegree() {
        return degree;
    }

    public void setDegree(Boolean degree) {
        this.degree = degree;
    }

    public Boolean getRepair() {
        return repair;
    }

    public void setRepair(Boolean repair) {
        this.repair = repair;
    }

    public Boolean getGraduated() {
        return graduated;
    }

    public void setGraduated(Boolean graduated) {
        this.graduated = graduated;
    }

    public Boolean getFinished() {
        return finished;
    }

    public void setFinished(Boolean finished) {
        this.finished = finished;
    }

    public Long getStudentId() {
        return studentId;
    }

    public void setStudentId(Long studentId) {
        this.studentId = studentId;
    }

    public String getOrgName() {
        return orgName;
    }

    public String getPhone() {
        return phone;
    }

    public void setPhone(String phone) {
        this.phone = phone;
    }

    public String getInfoCollector() {
        return infoCollector;
    }

    public void setInfoCollector(String infoCollector) {
        this.infoCollector = infoCollector;
    }

    public void setOrgName(String orgName) {
        this.orgName = orgName;
    }

    public String getSpecialtyCode() {
		return specialtyCode;
	}

	public void setSpecialtyCode(String specialtyCode) {
		this.specialtyCode = specialtyCode;
	}
	
	public Integer getNormalExamTimes() {
		return normalExamTimes;
	}

	public void setNormalExamTimes(Integer normalExamTimes) {
		this.normalExamTimes = normalExamTimes;
	}

	public Boolean getIsReexamine() {
		return isReexamine;
	}

	public void setIsReexamine(Boolean isReexamine) {
		this.isReexamine = isReexamine;
	}

	public String getReexamineType() {
		return reexamineType;
	}

	public void setReexamineType(String reexamineType) {
		this.reexamineType = reexamineType;
	}

	public String getReexamineDetail() {
		return reexamineDetail;
	}

	public void setReexamineDetail(String reexamineDetail) {
		this.reexamineDetail = reexamineDetail;
	}

	public Boolean getReexamineCompleted() {
		return reexamineCompleted;
	}

	public void setReexamineCompleted(Boolean reexamineCompleted) {
		this.reexamineCompleted = reexamineCompleted;
	}

    public Boolean getReexamine() {
        return isReexamine;
    }

    public void setReexamine(Boolean reexamine) {
        isReexamine = reexamine;
    }

    public String getExamBeginTime() {
        return examBeginTime;
    }

    public void setExamBeginTime(String examBeginTime) {
        this.examBeginTime = examBeginTime;
    }

    public String getExamEndTime() {
        return examEndTime;
    }

    public void setExamEndTime(String examEndTime) {
        this.examEndTime = examEndTime;
    }

    public Boolean getCanUpload() {
        return canUpload;
    }

    public void setCanUpload(Boolean canUpload) {
        this.canUpload = canUpload;
    }
}
